version: "2.1"
services:
  prometheus:
    image: prom/prometheus:v2.32.1
    container_name: monitoring_prometheus
    restart: always
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      # - prometheus_data:/data
    command:
      - '--config.file=/etc/prometheus/prometheus.yml'
      - '--storage.tsdb.path=/prometheus'
    expose:
      - 9090
    ports:
      - 9090:9090
    links:
      - cadvisor:cadvisor
      - node-exporter:node-exporter

  node-exporter:
    image: prom/node-exporter:v1.3.1
    container_name: monitoring_node_exporter
    restart: always
    expose:
      - 9100

  cadvisor:
    image: google/cadvisor:v0.33.0
    container_name: monitoring_cadvisor
    restart: always
    volumes:
      - /:/rootfs:ro
      - /var/run:/var/run:rw
      - /sys:/sys:ro
      - /var/lib/docker/:/var/lib/docker:ro
    expose:
      - 8080
  
  grafana:
    image: grafana/grafana:8.3.3
    container_name: monitoring_grafana
    restart: always
    links:
      - prometheus:prometheus
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      # - grafana:/data
    expose:
      - 3000
    ports:
      - 3000:3000
    links:
      - prometheus:prometheus    
    environment:
      - GF_INSTALL_PLUGINS=grafana-piechart-panel

